Types in EJ2 JavaScript Sidebar

21 Aug 202616 minutes to read

The Sidebar control’s expand behavior can be modified based on its intended use.

Expanding types of Sidebar

The Sidebar can be initialized with one of four different types, each consistent with the main control, as explained below. When dataBind is invoked, it applies any pending property changes immediately to the control.

Item Description
Over Sidebar floats over the main content area.
Push Sidebar pushes the main content area to appear side-by-side, and shrinks the main content within the screen width.
Slide Sidebar translates the x and y positions of the main content area based on the Sidebar width. The main content area will not be adjusted within the screen width.
Auto Sidebar has the Over type in mobile resolution, and Push type in other higher resolutions.

Auto is the default expand mode. The Sidebar with type Auto will always expand on initial rendering, irrespective of enableDock and isOpen properties.

In the following sample, the types of Sidebar are demonstrated.

ej.base.enableRipple(true);
//Sidebar initialization
var defaultSidebar = new ej.navigations.Sidebar({
    type: "Push",
    target: document.querySelector('.maincontent')
});
defaultSidebar.appendTo('#default-sidebar');
//end of Sidebar initialization

//toggle button initialization

var togglebtn = new ej.buttons.Button({ iconCss: 'e-icons burg-icon', isToggle: true, content: 'Open' }, '#toggle');

//Click Event.
document.getElementById('toggle').onclick = function () {
    if (document.getElementById('toggle').classList.contains('e-active')) {
        togglebtn.content = 'Close';
        defaultSidebar.show();
    } else {
        togglebtn.content = 'Open';
        defaultSidebar.hide();
    }
};

// Close the Sidebar
document.getElementById('close').onclick = function () {
    defaultSidebar.hide();
    document.getElementById('toggle').classList.remove('e-active');
    togglebtn.content = 'Open'
};

var typeOver = new ej.buttons.RadioButton({ label: 'Over', name: 'state', checked: true, change: Change });
typeOver.appendTo('#over');

//unchecked state.
var typePush = new ej.buttons.RadioButton({ label: 'Push', name: 'state', change: Change });
typePush.appendTo('#push');

var typeSlide = new ej.buttons.RadioButton({ label: 'Slide', name: 'state', change: Change });
typeSlide.appendTo('#slide');

//unchecked state.
var typeAuto = new ej.buttons.RadioButton({ label: 'Auto', name: 'state', change: Change });
typeAuto.appendTo('#auto');

// Change the type of the Sidebar
function Change(args) {
    if (args.event.target.id == "over") {
        defaultSidebar.type = "Over";
        defaultSidebar.dataBind();
    } else if (args.event.target.id == "push") {
        defaultSidebar.type = "Push";
        defaultSidebar.dataBind();
    }
    else if (args.event.target.id == "slide") {
        defaultSidebar.type = "Slide";
        defaultSidebar.dataBind();
    }
    else {
        defaultSidebar.type = "Auto";
        defaultSidebar.dataBind();
    }
}
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Essential JS 2 Sidebar</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0-beta.3/css/bootstrap.min.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-base/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-buttons/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-lists/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-navigations/styles/bootstrap5.3.css" rel="stylesheet">
    <link href="styles.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/ej2-buttons/styles/bootstrap5.3.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/35.1.37/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    <div id="container">
        <!-- Sidebar element declaration-->
        <aside id="default-sidebar">
            <div class="title"> Sidebar content</div>
            <div id="list"></div>
            <div class="sub-title">
                Click the button to close the Sidebar.
            </div>
            <div class="center-align">
                <button id="close" class="e-btn close-btn">Close Sidebar</button>
            </div>
        </aside>
        <!-- end of Sidebar element -->
        <!-- main content declaration -->

        <div id="head">
            <button id="toggle" class="e-btn e-info"></button>
        </div>
        <div class="maincontent" style="height:335px;border:1px solid gray">
            <div class="content">
                <div class="title">Main content</div>
                <div class="sub-title">
                    <div class="radiobutton">
                        <input type="radio" id="over">
                    </div>
                    <div class="radiobutton">
                        <input type="radio" id="push">
                    </div>
                    <div class="radiobutton">
                        <input type="radio" id="slide">
                    </div>
                    <div class="radiobutton">
                        <input type="radio" id="auto">
                    </div>
                </div>
            </div>
        </div>
        <!-- end of main content -->
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
    <style>
        .header {
            width: 100%;
            height: 40px;
            font-size: 20px;
            line-height: 40px;
            font-weight: 500;
            background: #eee;
            display: inline-block;
        }

        .center-align {
            text-align: center;
            padding: 20px;
        }

        .e-menu:before {
            content: '\e10d';
            font-size: 16px;
        }

        .title {
            text-align: center;
            font-size: 20px;
            padding: 15px;
        }

        #head {
            border: 1px solid #424242;
            border-bottom-color: transparent;
            background: #00897B;
        }

        #container .e-btn.e-info,
        #container .e-btn.e-info:hover,
        #container .e-btn.e-info:focus {
            /* csslint allow: adjoining-classes*/
            background: #00695C;
            box-shadow: none;
            border-radius: 0;
            height: 39px;
            width: 100px;
        }

        #close,
        #close:hover,
        #close:active,
        #close:focus {
            /* csslint allow: adjoining-classes*/
            background: #fafafa;
            color: black
        }

        .sub-title {
            text-align: center;
            font-size: 16px;
            padding: 10px;
        }

        .radiobutton {
            padding: 10px;
        }

        .content {
            width: 100%;
            height: 334px;
        }

        .center {
            text-align: center;
            display: none;
            font-size: 13px;
            font-weight: 400;
            margin-top: 20px;
        }

        #default-sidebar {
            background-color: #26A69A;
            color: #ffffff;
        }

        .close-btn:hover {
            color: #fafafa;
        }
    </style>
</body>

</html>
#container {
    visibility: hidden;
}

#loader {
    color: #008cff;
    height: 40px;
    width: 30%;
    position: absolute;
    top: 45%;
    left: 45%;
}

See Also

Variations in Angular Sidebar

26 Sep 202610 minutes to read

The Angular Sidebar component’s expand behaviour can be modified based on the purpose of use.

Expanding types of Angular Sidebar

The Angular Sidebar can be set to initialize based on four different types that are consistent with the main component as explained below.

Item Description
Over Sidebar floats over the main content area.
Push Sidebar pushes the main content area aside, appearing side-by-side, and shrinks the main content within the screen width.
Slide Sidebar shifts the main content area’s x and y positions based on the Sidebar width. The main content area is not adjusted to fit within the screen width.
Auto Sidebar with Over type in mobile resolution, and Push type in other higher resolutions.

Note: Auto is the default expand mode.

In the following sample, the types of Angular Sidebar are demonstrated.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { SidebarModule } from '@syncfusion/ej2-angular-navigations'
import { ButtonModule, RadioButtonModule  } from '@syncfusion/ej2-angular-buttons'




import { Component, ViewChild  } from '@angular/core';
import { SidebarComponent } from '@syncfusion/ej2-angular-navigations';
import { ButtonComponent, RadioButtonComponent } from '@syncfusion/ej2-angular-buttons';

@Component({
imports: [
        
        SidebarModule, ButtonModule, RadioButtonModule 
    ],


standalone: true,
    selector: 'app-root',
    styleUrls: ['./app.component.css'],
    template: `  <ejs-sidebar id="default-sidebar" #sidebar [type]='type' [target]='target' (created)="onCreated($event)" style="visibility: hidden">
                        <div class="title"> Sidebar content</div>
                        <div class="sub-title">
                            Click the button to close the Sidebar.
                        </div>
                        <div class="center-align">
                            <button ejs-button id="close" (click)="closeClick()" class="e-btn close-btn">Close Sidebar</button>
                        </div>
                    </ejs-sidebar>
                    <div>
                    <div id="head">
                        <button ejs-button id="toggle" #togglebtn cssClass="e-flat" iconCss="e-icons burg-icon" isToggle="true" (click)="btnClick()" content="Open"></button>
                    </div>
                    <div id="maincontent" class="content">
                        <div>
                            <div class="title">Main content</div>
                            <div class="rows">
                                <div class="row">
                                    <ejs-radiobutton id='push' #radio label="Push" name="type" checked="true" (change)="changeHandler($event)"></ejs-radiobutton>
                                </div>
                                <div class="row">
                                    <ejs-radiobutton id='slide' #radio label="Slide" name="type" (change)="changeHandler($event)"></ejs-radiobutton>
                                </div>
                                <div class="row">
                                    <ejs-radiobutton id='over' #radio label="Over" name="type"  (change)="changeHandler($event)"></ejs-radiobutton>
                                </div>
                                <div class="row">
                                    <ejs-radiobutton id='auto' #radio label="Auto" name="type" (change)="changeHandler($event)"></ejs-radiobutton>
                                </div>
                            </div>
                        </div>
                        </div>
                        </div>`
})
export class AppComponent {
    onCreated($event: any) {
    }
    @ViewChild('sidebar') sidebar?: SidebarComponent;
    @ViewChild('togglebtn') togglebtn?: ButtonComponent;

    public type: string = 'Push';
    public target: string = '.content';
    btnClick(){
        if((this.togglebtn as ButtonComponent).element.classList.contains('e-active')){
            (this.togglebtn as ButtonComponent).content = 'Open';
            this.sidebar?.hide();
        }
        else{
            (this.togglebtn as ButtonComponent).content = 'Close';
            this.sidebar?.show();
        }
    }
    closeClick() {
        this.sidebar?.hide();
        (this.togglebtn as ButtonComponent).element.classList.remove('e-active');
        (this.togglebtn as ButtonComponent).content = 'Open'
    }
    changeHandler(args: any) : void {
        if(args.event.target.ej2_instances[0].label == 'Over') {
            (this.sidebar as SidebarComponent).type = 'Over';
        } else if (args.event.target.ej2_instances[0].label == 'Push') {
            (this.sidebar as SidebarComponent).type = 'Push';
        } else if (args.event.target.ej2_instances[0].label == 'Slide') {
            (this.sidebar as SidebarComponent).type = 'Slide';
        } else {
            (this.sidebar as SidebarComponent).type = 'Auto';
        }
    }
}
@import 'node_modules/@syncfusion/ej2-base/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-base/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-navigations/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-buttons/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-lists/styles/material3.css';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Variations in Vue Sidebar

20 Aug 202624 minutes to read

The Sidebar component’s expand behavior can be modified based on its intended use.

Expanding types of sidebar

The Sidebar can be set to initialize based on four different types that are consistent with the main component as explained below. When dataBind is invoked, it applies the pending property changes immediately to the component.

Item Description
Over Sidebar floats over the main content area.
Push Sidebar pushes the main content area to appear side-by-side and shrinks the main content to fit within the screen width.
Slide Sidebar translates the x and y positions of the main content area based on the Sidebar width.
Auto Sidebar with Over type in mobile resolution, and Push type in other higher resolutions.

Auto is the default expand mode.

In the following sample, the types of Sidebar are demonstrated.

<template>
    <div id="app">
        <ejs-sidebar id="default-sidebar" ref="sidebar" :type="type" :target="target">
            <div class="title"> Sidebar content</div>
            <div class="sub-title">
                Click the button to close the Sidebar.
            </div>
            <div class="center-align">
                <button ejs-button id="close" v-on:click="closeClick" class="e-btn close-btn">Close Sidebar</button>
            </div>
        </ejs-sidebar>
        <div id="head">
            <ejs-button id="toggle" ref="togglebtn" cssClass="e-flat" iconCss="e-icons e-menu" isToggle="true"
                v-on:click="btnClick">Open</ejs-button>
        </div>
        <div>
            <div id="maincontent" class="content">
                <div>
                    <div class="title">Main content</div>
                    <div class="rows">
                        <div class="row">
                            <ejs-radiobutton id='push' label="Push" name="type"
                                :change="changeHandler"></ejs-radiobutton>
                        </div>
                        <div class="row">
                            <ejs-radiobutton id='slide' label="Slide" name="type"
                                :change="changeHandler"></ejs-radiobutton>
                        </div>
                        <div class="row">
                            <ejs-radiobutton id='over' label="Over" name="type"
                                :change="changeHandler"></ejs-radiobutton>
                        </div>
                        <div class="row">
                            <ejs-radiobutton id='auto' label="Auto" name="type" checked="true"
                                :change="changeHandler"></ejs-radiobutton>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script setup>

    import { SidebarComponent as EjsSidebar } from '@syncfusion/ej2-vue-navigations';
    import { ButtonComponent as EjsButton, RadioButtonComponent as EjsRadiobutton } from '@syncfusion/ej2-vue-buttons';
    import { ref } from 'vue';

    const sidebar = ref(null);
    const togglebtn = ref(null);
    const type = ref('Push');
    const target = '.content';

    const btnClick = () => {
        if (togglebtn.value.$el.classList.contains('e-active')) {
            togglebtn.value.content = 'Open';
            sidebar.value.hide();
        }
        else {
            togglebtn.value.content = 'Close';
            sidebar.value.show();
        }
    };
    const closeClick = () => {
        sidebar.value.hide();
        togglebtn.value.$el.classList.remove('e-active');
        togglebtn.value.content = 'Open';
    };
    const changeHandler = (args) => {
        if (args.event.target.id == 'over') {
            type.value = 'Over';
        } else if (args.event.target.id == 'push') {
            type.value = 'Push';
        } else if (args.event.target.id == 'slide') {
            type.value = 'Slide';
        } else {
            type.value = 'Auto';
        }
    };
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";

.rows{
    margin:auto;
    text-align:center;
}

.row{
    padding:10px;
    margin:auto;
}

.header {
    width:100%;
    height: 40px;
    font-size:20px;
    line-height: 40px;
    font-weight: 500;
    background: #eee;
    display: inline-block;
}

.center-align {
    text-align: center;
    padding: 20px;
  }
  
  .title {
    text-align: center;
    font-size: 20px;
    padding: 15px;
  }
  
  #head {
    border: 1px solid #424242;
    border-bottom-color: transparent;
    background: #00897b;
  }
  
  #toggle {
    /*csslintallow:adjoining-classes*/
    background: #00695c;
    box-shadow: none;
    border-radius: 0;
    height: 39px;
    width: 100px;
  }
  
  #close {
    /* csslint allow: adjoining-classes*/
    background: #fafafa;
    color: black;
  }
  
  .sub-title {
    text-align: center;
    font-size: 16px;
    padding: 10px;
  }
  
  #default-sidebar {
    background-color: #26a69a;
    color: #ffffff;
  }
  
  .content {
    height: 305px;
    border: 1px solid grey;
  }
  
  #toggle {
    color: white;
  }
</style>
<template>
    <div id="app">
        <ejs-sidebar id="default-sidebar" ref="sidebar" :type="type" :target="target">
            <div class="title"> Sidebar content</div>
            <div class="sub-title">
                Click the button to close the Sidebar.
            </div>
            <div class="center-align">
                <button ejs-button id="close" v-on:click="closeClick" class="e-btn close-btn">Close Sidebar</button>
            </div>
        </ejs-sidebar>
        <div id="head">
            <ejs-button id="toggle" ref="togglebtn" cssClass="e-flat" iconCss="e-icons e-menu" isToggle="true"
                v-on:click.native="btnClick" :content ="contentValue">Open</ejs-button>
        </div>
        <div>
            <div id="maincontent" class="content">
                <div>
                    <div class="title">Main content</div>
                    <div class="rows">
                        <div class="row">
                            <ejs-radiobutton id='push' label="Push" name="type"
                                :change="changeHandler"></ejs-radiobutton>
                        </div>
                        <div class="row">
                            <ejs-radiobutton id='slide' label="Slide" name="type"
                                :change="changeHandler"></ejs-radiobutton>
                        </div>
                        <div class="row">
                            <ejs-radiobutton id='over' label="Over" name="type"
                                :change="changeHandler"></ejs-radiobutton>
                        </div>
                        <div class="row">
                            <ejs-radiobutton id='auto' label="Auto" name="type" checked="true"
                                :change="changeHandler"></ejs-radiobutton>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>

    import { SidebarComponent } from '@syncfusion/ej2-vue-navigations';
    import { ButtonComponent, RadioButtonComponent } from '@syncfusion/ej2-vue-buttons';

    export default {
        name: "App",
        components: {
            "ejs-sidebar": SidebarComponent,
            "ejs-button": ButtonComponent,
            "ejs-radiobutton": RadioButtonComponent
        },
        data() {
            return {
                type: 'Push',
                target: '.content',
                content: "Open",
            }
        },
        computed: {
            contentValue: {
            get: function () {
                return this.content;
            },
            set: function (content) {
                this.content = content
            }
            }
        },
        methods: {
            btnClick: function () {
                if (this.$refs.togglebtn.$el.classList.contains('e-active')) {
                    this.contentValue='Open';
                    this.$refs.sidebar.hide();
                }
                else {
                    this.contentValue='Close';
                    this.$refs.sidebar.show();
                }
            },
            closeClick: function () {
                this.$refs.sidebar.hide();
                this.$refs.togglebtn.$el.classList.remove('e-active');
                this.contentValue='Open';
            },
            changeHandler: function (args) {
                if (args.event.target.id == 'over') {
                    this.type = 'Over';
                    this.$refs.togglebtn.dataBind();
                } else if (args.event.target.id == 'push') {
                    this.type = 'Push';
                    this.$refs.togglebtn.dataBind();
                } else if (args.event.target.id == 'slide') {
                    this.type = 'Slide';
                    this.$refs.togglebtn.dataBind();
                } else {
                    this.type = 'Auto';
                    this.$refs.togglebtn.dataBind();
                }
            }
        }
    }
</script>

<style>
    @import "../node_modules/@syncfusion/ej2-base/styles/material.css";
    @import "../node_modules/@syncfusion/ej2-buttons/styles/material.css";
    @import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";

    .rows{
        margin:auto;
        text-align:center;
    }

    .row{
        padding:10px;
        margin:auto;
    }

    .header {
        width:100%;
        height: 40px;
        font-size:20px;
        line-height: 40px;
        font-weight: 500;
        background: #eee;
        display: inline-block;
    }

  .center-align {
    text-align: center;
    padding: 20px;
  }
  
  .title {
    text-align: center;
    font-size: 20px;
    padding: 15px;
  }
  
  #head {
    border: 1px solid #424242;
    border-bottom-color: transparent;
    background: #00897b;
  }
  
  #toggle {
    /*csslintallow:adjoining-classes*/
    background: #00695c;
    box-shadow: none;
    border-radius: 0;
    height: 39px;
    width: 100px;
  }
  
  #close {
    /* csslint allow: adjoining-classes*/
    background: #fafafa;
    color: black;
  }
  
  .sub-title {
    text-align: center;
    font-size: 16px;
    padding: 10px;
  }
  
  #default-sidebar {
    background-color: #26a69a;
    color: #ffffff;
  }
  
  .content {
    height: 305px;
    border: 1px solid grey;
  }
  
  #toggle {
    color: white;
  }
</style>

See Also